function velocity(x,y,z,ips)
common/flat_sf/key_flat1
common/topo/nxx,xmin,xmax,nyy,ymin,ymax,htopo(1500,1500),topomin,topomax
vel_min=0.5
vsea=1.44

rz=6371
!write(*,*)' topomin=',topomin,' z=',z

if (z.le.topomin) then
    ztopo=topo_xy(x,y)
    !write(*,*)' z=',z,' ztopo=',ztopo

    if(z.lt.ztopo) then
        velocity = vsea
        return
    end if
end if


depth = sph_flat(key_flat1,x,y,z)

v0=vrefmod(depth,ips)

dv_apr= 0.01 * vert_anom(x,y,z,ips) * v0

dv = anom_3D_xyz_lin_v(x,y,z,ips)


velocity = v0 + dv + dv_apr

if(velocity .lt. vel_min) velocity = vel_min


return
end