subroutine read_topo(ar)
character*8 md,ar
character*4 dsaa/'DSAA'/
real htopo_ft(1500,1500)
common/topo/nxx,xmin,xmax,nyy,ymin,ymax,htopo(1500,1500),topomin,topomax
common/center/ fi0,tet0

nfi=0
topomin=0
topomax=0
write(*,*)' read_topo'

open(1,file='../../../DATA/'//ar//'/inidata/topo_xyz.grd',status='old',err=1)

read(1,*)
read(1,*)nxx,nyy
!write(*,*)nxx,nyy
read(1,*)xmin,xmax
read(1,*)ymin,ymax
read(1,*)hmin,hmax
do iyy=1,nyy
!write(*,*)' iyy=',iyy
	read(1,*)(htopo(ixx,iyy),ixx=1,nxx)
end do
close(1)

!stop

!htopo=htopo/1000.

topomin=999999
topomax=-999999

do ixx=1,nxx
    do iyy=1,nyy
        if(htopo(ixx,iyy).gt.topomax) topomax=htopo(ixx,iyy)
        if(htopo(ixx,iyy).lt.topomin) topomin=htopo(ixx,iyy)
    end do
end do
topomin=-topomin/1000.
topomax=-topomax/1000.
write(*,*)' topomin=',topomin,' topomax=',topomax
!write(*,*)' nar=',nar
return

1 continue
  write(*,*)' ar=',ar

open(1,file='../../../DATA/'//ar//'/inidata/topo_ftz.grd',status='old',err=2)
read(1,*)
read(1,*)nff,ntt
!write(*,*)nff,ntt
read(1,*)fmin,fmax
read(1,*)tmin,tmax
read(1,*)hmin,hmax
do itt=1,ntt
	read(1,*)(htopo_ft(iff,itt),iff=1,nff)
end do
close(1)
dff=(fmax-fmin)/(nff-1)
dtt=(tmax-tmin)/(ntt-1)


call SFDEC(fmin,tmin,0.,x1,y1,Z,fi0,tet0)
call SFDEC(fmax,tmin,0.,x2,y2,Z,fi0,tet0)
call SFDEC(fmin,tmax,0.,x3,y3,Z,fi0,tet0)
call SFDEC(fmax,tmax,0.,x4,y4,Z,fi0,tet0)
xmin=x1; if(x2.lt.xmin)xmin=x2; if(x3.lt.xmin)xmin=x3; if(x4.lt.xmin)xmin=x4
xmax=x1; if(x2.gt.xmax)xmax=x2; if(x3.gt.xmax)xmax=x3; if(x4.gt.xmax)xmax=x4
ymin=y1; if(y2.lt.ymin)ymin=y2; if(y3.lt.ymin)ymin=y3; if(y4.lt.ymin)ymin=y4
ymax=y1; if(y2.gt.ymax)ymax=y2; if(y3.gt.ymax)ymax=y3; if(y4.gt.ymax)ymax=y4
nxx=nff; nyy=ntt


write(*,*)' fmin,fi0,fmax=',fmin,fi0,fmax
write(*,*)' tmin,tet0,tmax=',tmin,tet0,tmax


write(*,*)' nxx=',nxx,' nyy=',nyy
write(*,*)' xmin=',xmin,' xmax=',xmax
write(*,*)' ymin=',ymin,' ymax=',ymax
dxx=(xmax-xmin)/(nxx-1)
dyy=(ymax-ymin)/(nyy-1)

do iff=1,nff
    do itt=1,ntt
        if(abs(htopo_ft(iff,itt)).gt.20000.) htopo_ft(iff,itt)=0.
    end do
end do

hmin=99999; hmax=-99999
do ixx=1,nxx
    xxx=xmin+(ixx-1)*dxx
    do iyy=1,nyy
        yyy=ymin+(iyy-1)*dyy

        call decsf(xxx,yyy,0.,fi0,tet0,fff,ttt,h)
        
        if(fff.lt.fmin) then
            if1=1; if2=1; f1=fmin; f2=fmin+dff
        else if(fff.gt.fmax) then
            if1=nxx; if2=nxx; f1=fmax; f2=fmax+dff
        else
            do iff=1,nff-1
                f1=fmin+(iff-1)*dff
                f2=fmin+iff*dff
                if1=iff; if2=iff+1
                if((fff-f1)*(fff-f2).le.0.) exit
            end do
        end if

        if(ttt.lt.tmin) then
            it1=1; it2=1; t1=tmin; t2=tmin+dtt
        else if(ttt.gt.tmax) then
            it1=nyy; it2=nyy; t1=tmax; t2=tmax+dtt
        else
            do itt=1,ntt-1
                t1=tmin+(itt-1)*dtt
                t2=tmin+itt*dtt
                it1=itt; it2=itt+1
                if((ttt-t1)*(ttt-t2).le.0.) exit
            end do
        end if

        !write(*,*)' fff=',fff,' f1=',f1,' f2=',f2,' if1=',if1,' if2=',if2
        !write(*,*)' ttt=',ttt,' t1=',t1,' t2=',t2,' it1=',it1,' it2=',it2

        h11=htopo_ft(if1,it1)
        h12=htopo_ft(if1,it2)
        h21=htopo_ft(if2,it1)
        h22=htopo_ft(if2,it2)

        h1=h11+(h11-h12)*(ttt-t1)/(t1-t2)
        h2=h21+(h21-h22)*(ttt-t1)/(t1-t2)

        hhh=h1+(h1-h2)*(fff-f1)/(f1-f2)

        htopo(ixx,iyy) = hhh

        if (hhh.lt.hmin) hmin=hhh
        if (hhh.gt.hmax) hmax=hhh

        !write(*,*)h11,h12,h21,h22
        !write(*,*)h1,h2
        !write(*,*)hhh

    end do
end do

open(11,file='../../../DATA/'//ar//'/inidata/topo_xyz.grd')
write(11,'(a4)')dsaa
write(11,*)nxx,nyy
write(11,*)xmin,xmax
write(11,*)ymin,ymax
write(11,*)hmin,hmax
do iyy=1,nyy
	write(11,*)(htopo(ixx,iyy),ixx=1,nxx)
end do
close(11)

write(*,*)' Topography hs been converted from FT to XY'

2 continue
return
end